//-f

#version 3.7;

global_settings {assumed_gamma 2.2}

#local CameraZ = 10;

camera {
   location <0, 0, -CameraZ>
   direction <0, 0, 1>
   look_at <0, 0, 0>
} //camera

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

//Set these variables:

#local Randomizer = seed (0);

#local GridMultiplier = 11; //Grid will be 11 * GridMultiplier blocks wide by 3 * GridMultiplier blocks high

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#local NColorBlockColors = 3;

#local ColorBlockColor = array [NColorBlockColors] {
   <206, 193, 177> / 256,
   <153, 146, 128> / 256,
   <100, 103, 94> / 256
} //array

#local NColorBlocks_X = GridMultiplier * 11;
#local NColorBlocks_Y = GridMultiplier * 3;

#local ColorBlockRow = array [NColorBlocks_Y]

#local ColorBlockIndex = array [NColorBlocks_X] [NColorBlocks_Y]

#for (I, 0, NColorBlocks_Y - 1)
   #for (J, 0, NColorBlocks_X - 1)
      #local ColorBlockIndex [J] [I] = int (rand (Randomizer) * NColorBlockColors);
      //The line above SHOULD be:
      //#local ColorBlockIndex [J] [I] = ***SOME FRACTAL FUNCTION THAT TAKES AN (X, Y) INPUT
      //AND RETURNS A RESULT THAT CAN BE CONVERTED TO 0, 1, OR 2***
   #end //#for
#end //#for

#local DeltaX = 1 / NColorBlocks_X;

#for (I, 0, NColorBlocks_Y - 1)
   #local ColorBlockRow [I] = texture {
      pigment {
         gradient x
         color_map {
            #for (J, 0, NColorBlocks_X - 1)
               [J * DeltaX color ColorBlockColor [ColorBlockIndex [J] [I]]]
               [(J + 1) * DeltaX color ColorBlockColor [ColorBlockIndex [J] [I]]]
            #end //#for
         } //color_map
      } //pigment
      finish {emission 1}
   } //texture
#end //#for

#local DeltaY = 1 / NColorBlocks_Y;

#local BackgroundColor = texture {
   gradient y
   texture_map {
      #for (I, 0, NColorBlocks_Y - 1)
         [I * DeltaY ColorBlockRow [I]]
         [(I + 1) * DeltaY ColorBlockRow [I]]
      #end //#for
   } //texture_map
   scale <11/3, 1, 1>
} //texture

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* *                                                                                                                 * */
/* *                                                                                                                 * */
/* * BACKGROUND                                                                                                      * */
/* *                                                                                                                 * */
/* *                                                                                                                 * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#local BackgroundScale = CameraZ / (2475 / 902); //Scale slightly larger to allow for anti-aliasing

#local Background = object {
   box {
      <-CameraZ * 2/3, 0, 0> <CameraZ * 2/3, 1, 1>
      texture {BackgroundColor}
      scale <BackgroundScale, BackgroundScale, 1>
      translate <-BackgroundScale * 11/6, -BackgroundScale / 2, 0>
   } //box
} //object

object {Background}
